/*
 * vim:ts=4:sw=4:expandtab
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdbool.h>
#include <stdint.h>
#include <signal.h>

struct eax {
    char *plt;
    uint8_t rdi[496];
    char *rax;
    char *eax;
} rsp = {
    "Baby, don't hack me. Don't hack me. No more.\n",
    "",
    "Programm erfolgreich registriert!\n",
    "Falsche Serial\n"
};

void validate_serial_number(int sig) {
    printf("Falsche Serial Number!\n");
    exit(0);
}

// gültig: Fnord.
int main() {
    signal(SIGSEGV, validate_serial_number);
    char serial[4096];
    printf("Bitte Serial Number eingeben:\n");
    scanf("%s", serial);

    // speicheradresse berechnen aus quersumme
    if (strlen(serial) < 5) {
        printf("Falsche Serial Number\n");
        return 1;
    }

    int sum = serial[0] + serial[1] + serial[2] + serial[3] + serial[4];
    uint8_t *base = (uint8_t*)&(rsp.plt);
    base += sum - 1;
    if (strlen(*((char**)base)) == 3) {
        printf("%s\n", *((char**)base));
    } else {
        printf("%s \n", *((char**)base));
    }
}
